Description

Pues eso, que a veces las dependecias opcionales en el config.xml son ignoradas.

A ver si te puedo explicar lo que visto.

Si cuando carga los plugins se encuentra esto, por este orden:

- PluginA
- PluginB depende de PluginA opcional

Lo hace bien, mete en el classloader de PluginB el PluginA. Pero si se encuentra:

- PluginB depende de PluginA opcional
- PluginA

Cuando carga el PluginB no tiene cargado el PluginA y no la añade al classloader, y
como es opcional decide que no bloquea la carga del PluginB y sigue la carga del resto
con el classloader de PluginB "chungo".

Sepodria hacer que cuando encuentra el PluginB, si existe la carpeta del PluginA (dependencyPluginConfig!=null), en lugar de
opcional lo trate como obligatorio, eso hara que continue la carga del resto sin cargar el B, y que lo intente en una segunda vuelta,
con lo que cuando lo intente de nuevo ya estara cargado el A y funcionara.

En general esto iria, pero si por lo que sea peta la carga del PluginA lo interpretara como que hay una referencia ciclica y gvSIG no
arrancara. No se lo grabe que puede ser esto. Se supone que tendria que haber un plugin con un config chungo o algo asi para que
esto pasese.

Creo que el codigo de Launcher.pluginsClassLoaders habria que rehacerlo y cambiar el
algoritmo que usa pare resolver las dependencias, pero nunca se cuando puede ser
el momento de tocarlo.

Related issues:
Related to Application: gvSIG desktop - gvSIG bugs # 2956: Raster calculator ... Closed 10/31/2014 02/13/2015

Associated revisions
Revision 42364 - 10/08/2015 09:48 PM - Joaquín  del Cerro Murciano
refs #2224. rehecho el algoritmo de decision del orden de carga e inicializacion de los plugins.

History
#1 - 02/18/2014 05:10 PM - Álvaro Anguix
- Assignee set to Joaquín  del Cerro Murciano

#2 - 02/20/2014 12:00 PM - Álvaro Anguix

Con los plugins que tenemos ahora (2220) no sucede.

#3 - 02/20/2014 12:03 PM - Ignacio Brodín

Esto se solucionó hace dos o tres builds. Comprobé que funcionara porque afectaba para algún proyecto de raster. Yo lo pondría a fixed si Joaquin no
dice lo contrario y en caso de que de problemas en el futuro se abre nuevamente.

#4 - 02/20/2014 12:09 PM - Álvaro Anguix
- Target version changed from 2.1.0-2223-rc1 to 2.2.0-2311-rc2

Lo dejamos abierto porque no sucede, pero podría suceder si cambian las dependencias de algún plugin.
Vamos, que se queda abierto, para estar alertas y saber que hay que arreglarlo a futuro (lo paso post-2.1).

#5 - 04/04/2014 10:36 AM - Álvaro Anguix
- Assignee deleted (Joaquín  del Cerro Murciano)

#6 - 01/23/2015 08:13 AM - Álvaro Anguix
- Related to gvSIG bugs #2956: Raster calculator simplified GUI added

#7 - 01/28/2015 12:05 PM - Álvaro Anguix
- Target version deleted (2.2.0-2311-rc2)

#8 - 10/08/2015 09:53 PM - Joaquín  del Cerro Murciano
- Severity set to Blocker
- Target version set to 2.3.0-2402
- Assignee set to Joaquín  del Cerro Murciano
- Status changed from New to Fixed

#9 - 10/15/2015 10:32 AM - Álvaro Anguix
- Status changed from Fixed to Closed
